//------------------------------------------------------------------------------
// <autogenerated>
//     This code was generated by Measurement Studio.
//     Runtime Version: 1.1.4322.573
//
//     Changes to this file may cause incorrect behavior and will be lost if 
//     the code is regenerated.
// </autogenerated>
//------------------------------------------------------------------------------

namespace InstrumentDriverInterop.Ivi
{
    using System;
    using System.Runtime.InteropServices;
    
    
    public class niSwitch : object, System.IDisposable
    {
        
        private System.IntPtr _handle;
        
        private bool _disposed = true;
        
        ~niSwitch(){Dispose(false);}

        /// <summary>
        /// Returns a session handle used to identify the switch module in all subsequent instrument driver calls. 
        /// 
        /// niSwitch_init creates a new IVI instrument driver session for the switch module specified in the resource name parameter. If multiple topologies are valid for that device, the driver uses the default topology specified in MAX.
        /// 
        /// By default, the switch module is reset to a known state.
        /// 
        /// An error is returned if a session to the specified resource exists in another process. The same session is returned if niSwitch_init is called twice in the same process for the same resource with the same topology. 
        /// 
        /// 
        /// </summary>
        /// <param name="Resource_Name">
        /// Resource name of the switch module to initialize.
        /// 
        /// Default value: None 
        /// 
        /// Syntax:
        /// 
        /// Optional fields are shown in square brackets ([]).
        /// 
        /// Configured in MAX Under         Valid Syntax 
        /// NI-DAQmx Devices                DAQmxDeviceName 
        /// Traditional NI-DAQ Devices      SCXI[chassis ID]::slot number 
        /// PXI System                      PXI[bus number]::device number 
        /// 
        /// TIP:  IVI logical names are also valid for the resource name. 
        /// 
        /// Default values for optional fields:
        /// 
        /// chassis ID = 1
        /// bus number = 0
        /// 
        /// Example resource names:
        /// 
        /// Resource Name    Description 
        /// SC1Mod3          NI-DAQmx module in chassis "SC1" slot 3 
        /// MySwitch         NI-DAQmx module renamed to "MySwitch" 
        /// SCXI1::3         Traditional NI-DAQ module in chassis 1, slot 3 
        /// SCXI::3          Traditional NI-DAQ module in chassis 1, slot 3 
        /// PXI0::16         PXI bus 0, device number 16 
        /// PXI::16          PXI bus 0, device number 16 
        /// 
        /// </param>
        /// <param name="ID_Query">
        /// This parameter is ignored. 
        /// 
        /// Because NI-SWITCH supports multiple switch modules, it always queries the switch device to determine which device is installed. For this reason, this VI may return NISWITCH_ERROR_FAIL_ID_QUERY even if this parameter is set to VI_FALSE. 
        /// 
        /// Valid Values: 
        /// VI_TRUE  - (Default Value)
        /// VI_FALSE - Currently unsupported.
        /// </param>
        /// <param name="Reset_Device">
        /// Specifies whether to reset the switch module during the initialization process. 
        /// Valid Values: 
        /// VI_TRUE - Reset Device (Default Value) 
        /// VI_FALSE - Currently unsupported. The device will not reset.
        /// </param>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        public niSwitch(string Resource_Name, bool ID_Query, bool Reset_Device)
        {
            int pInvokeResult = PInvoke.init(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset_Device), out this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            this._disposed = false;
        }
        
        /// <summary>
        /// Returns a session handle used to identify the switch module in all subsequent instrument driver calls and optionally sets the initial state of the session. 
        /// 
        /// niSwitch_InitWithOptions creates a new IVI instrument driver session for the switch module specified in the resource name parameter. If multiple topologies are valid for that device, the driver uses the default topology specified in MAX. The topology is also configurable in the options string parameter.
        /// 
        /// By default, the switch module is reset to a known state.
        /// 
        /// Enable simulation in the options string parameter.
        /// 
        /// An error is returned if a session to the specified resource exists in another process. The same session is returned if niSwitch_InitWithOptions is called twice in the same process for the same resource with the same topology. 
        /// 
        /// </summary>
        /// <param name="Resource_Name">
        /// Resource name of the switch module to initialize.
        /// 
        /// Default value: None 
        /// 
        /// Syntax:
        /// 
        /// Optional fields are shown in square brackets ([]).
        /// 
        /// Configured in MAX Under         Valid Syntax 
        /// NI-DAQmx Devices                DAQmxDeviceName 
        /// Traditional NI-DAQ Devices      SCXI[chassis ID]::slot number 
        /// PXI System                      PXI[bus number]::device number 
        /// 
        /// TIP:  IVI logical names are also valid for the resource name. 
        /// 
        /// Default values for optional fields:
        /// 
        /// chassis ID = 1
        /// bus number = 0
        /// 
        /// Example resource names:
        /// 
        /// Resource Name    Description 
        /// SC1Mod3          NI-DAQmx module in chassis "SC1" slot 3 
        /// MySwitch         NI-DAQmx module renamed to "MySwitch" 
        /// SCXI1::3         Traditional NI-DAQ module in chassis 1, slot 3 
        /// SCXI::3          Traditional NI-DAQ module in chassis 1, slot 3 
        /// PXI0::16         PXI bus 0, device number 16 
        /// PXI::16          PXI bus 0, device number 16 
        /// </param>
        /// <param name="ID_Query">
        /// This parameter is ignored. 
        /// 
        /// Because NI-SWITCH supports multiple switch modules, it always queries the switch device to determine which device is installed. For this reason, this VI may return NISWITCH_ERROR_FAIL_ID_QUERY even if this parameter is set to VI_FALSE. 
        /// 
        /// Valid Values: 
        /// VI_TRUE  - (Default Value)
        /// VI_FALSE - Currently unsupported.
        /// </param>
        /// <param name="Reset_Device">
        /// Specifies whether to reset the switch module during the initialization process. 
        /// Valid Values: 
        /// VI_TRUE - Reset Device (Default Value) 
        /// VI_FALSE - Currently unsupported. The device will not reset.
        /// </param>
        /// <param name="Options_String">
        /// Sets initial values of certain attributes for the NI-SWITCH session.
        /// 
        /// Default value: Simulate=0,RangeCheck=1,DriverSetup=topology:1127/2-Wire 32x1 Mux 
        /// 
        /// The following table lists the attribute string names you can use:
        /// 
        /// RangeCheck        1   NISWITCH_ATTR_RANGE_CHECK
        /// QueryInstrStatus  1   NISWITCH_ATTR_QUERY_INSTRUMENT_STATUS
        /// Cache             1   NISWITCH_ATTR_CACHE
        /// Simulate          0   NISWITCH_ATTR_SIMULATE
        /// RecordCoercions   0   NISWITCH_ATTR_RECORD_COERCIONS
        /// DriverSetup topology  1127/2-Wire 32x1 Mux 
        /// 
        /// 
        /// The format of the option string is, "AttributeStringName=Value" where AttributeStringName is the name of the attribute shown above and Value is the value to which the attribute will be set. To set multiple attributes, separate assignments with a comma. 
        /// 
        /// If you pass an empty string for this parameter, the NI-SWITCH session uses the default values for the attributes. You can override the default values by explicitly assigning a value. You do not have to specify all of the available attributes. If you do not specify an attribute, its default value is used. 
        /// 
        /// Use the DriverSetup attribute to set the topology or the resource type (DAQmx or Traditional DAQ) of the switch module. This attribute can contain config token/value pairs within it.
        /// 
        /// DriverSetup=[config token]:[value];[config token 2]:[value 2]
        /// 
        /// Valid Config Tokens and Values:
        /// 
        /// 
        /// 
        /// Token Value 
        /// topology  - Refer to Devices Overview for valid values. Default: MAX configured topology for each device. 
        /// 
        /// resourcetype  - "daqmx" for devices configured under NI-DAQmx Devices in MAX or "legacy" for devices configured under Traditional NI-DAQ Devices in MAX. Default: daqmx 
        /// 
        /// For example, use the following string to set an NI SCXI-1127 as a 2-wire 32x1 multiplexer configured in MAX under DAQmx Devices: 
        /// 
        /// "DriverSetup=topology:1127/2-Wire 32x1 Mux;resourcetype:daqmx"
        /// 
        /// The DriverSetup string is particularly important when using NI-SWITCH through the IviSwitch class driver. 
        /// 
        /// To enable simulation, set simulate equal to 1 and specify the switch module and topology of the switch module to simulate. The following string enables simulation for an SCXI-1127 configured as a 2-wire 32x1 multiplexer.
        /// 
        /// "Simulate=1, DriverSetup=topology:1127/2-Wire 32x1 Mux"
        /// 
        /// If simulate is set to 1 and the DriverSetup string specifies a topology, the topology is used to determine which device to simulate. If the DriverSetup string does not specify a topology, the device specified in resource name is simulated. 
        /// </param>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        public niSwitch(string Resource_Name, bool ID_Query, bool Reset_Device, string Options_String)
        {
            int pInvokeResult = PInvoke.InitWithOptions(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset_Device), Options_String, out this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            this._disposed = false;
        }
        
        /// <summary>
        /// Returns a session handle used to identify the switch module in all subsequent instrument driver calls and sets the topology of the switch module. 
        /// 
        /// niSwitch_InitWithTopology creates a new IVI instrument driver session for the switch module specified in the resource name parameter. The driver uses the topology specified in the topology name parameter and overrides the topology specified in MAX.
        /// 
        /// By default, the switch module is reset to a known state.
        /// 
        /// Enable simulation by specifying the topology and setting the simulate parameter to VI_TRUE. 
        /// 
        /// </summary>
        /// <param name="Resource_Name">
        /// Resource name of the switch module to initialize.
        /// 
        /// Default value: None 
        /// 
        /// Syntax:
        /// 
        /// Optional fields are shown in square brackets ([]).
        /// 
        /// Configured in MAX Under         Valid Syntax 
        /// NI-DAQmx Devices                DAQmxDeviceName 
        /// Traditional NI-DAQ Devices      SCXI[chassis ID]::slot number 
        /// PXI System                      PXI[bus number]::device number 
        /// 
        /// TIP:  IVI logical names are also valid for the resource name. 
        /// 
        /// Default values for optional fields:
        /// 
        /// chassis ID = 1
        /// bus number = 0
        /// 
        /// Example resource names:
        /// 
        /// Resource Name    Description 
        /// SC1Mod3          NI-DAQmx module in chassis "SC1" slot 3 
        /// MySwitch         NI-DAQmx module renamed to "MySwitch" 
        /// SCXI1::3         Traditional NI-DAQ module in chassis 1, slot 3 
        /// SCXI::3          Traditional NI-DAQ module in chassis 1, slot 3 
        /// PXI0::16         PXI bus 0, device number 16 
        /// PXI::16          PXI bus 0, device number 16 
        /// </param>
        /// <param name="Topology">
        /// Pass the topology name you want to use for the switch you specify with Resource Name parameter. 
        /// Default Value: 
        /// NISWITCH_TOPOLOGY_1127_2_WIRE_32X1_MUX 
        /// 
        /// Valid Values: 
        /// NISWITCH_TOPOLOGY_1127_1_WIRE_64X1_MUX 
        /// NISWITCH_TOPOLOGY_1127_2_WIRE_32X1_MUX 
        /// NISWITCH_TOPOLOGY_1127_2_WIRE_4X8_MATRIX 
        /// NISWITCH_TOPOLOGY_1127_4_WIRE_16X1_MUX 
        /// NISWITCH_TOPOLOGY_1127_INDEPENDENT 
        /// NISWITCH_TOPOLOGY_1128_1_WIRE_64X1_MUX 
        /// NISWITCH_TOPOLOGY_1128_2_WIRE_32X1_MUX 
        /// NISWITCH_TOPOLOGY_1128_2_WIRE_4X8_MATRIX 
        /// NISWITCH_TOPOLOGY_1128_4_WIRE_16X1_MUX 
        /// NISWITCH_TOPOLOGY_1128_INDEPENDENT 
        /// NISWITCH_TOPOLOGY_1129_2_WIRE_16X16_MATRIX 
        /// NISWITCH_TOPOLOGY_1129_2_WIRE_8X32_MATRIX 
        /// NISWITCH_TOPOLOGY_1129_2_WIRE_4X64_MATRIX 
        /// NISWITCH_TOPOLOGY_1129_2_WIRE_DUAL_8X16_MATRIX 
        /// NISWITCH_TOPOLOGY_1129_2_WIRE_DUAL_4X32_MATRIX 
        /// NISWITCH_TOPOLOGY_1129_2_WIRE_QUAD_4X16_MATRIX 
        /// NISWITCH_TOPOLOGY_1130_1_WIRE_256X1_MUX 
        /// NISWITCH_TOPOLOGY_1130_1_WIRE_4X64_MATRIX 
        /// NISWITCH_TOPOLOGY_1130_1_WIRE_8x32_MATRIX 
        /// NISWITCH_TOPOLOGY_1130_2_WIRE_4X32_MATRIX 
        /// NISWITCH_TOPOLOGY_1130_2_WIRE_128X1_MUX 
        /// NISWITCH_TOPOLOGY_1130_4_WIRE_64X1_MUX 
        /// NISWITCH_TOPOLOGY_1130_INDEPENDENT 
        /// NISWITCH_TOPOLOGY_1160_16_SPDT 
        /// NISWITCH_TOPOLOGY_1161_8_SPDT 
        /// NISWITCH_TOPOLOGY_1163R_OCTAL_4X1_MUX 
        /// NISWITCH_TOPOLOGY_1166_32_SPDT 
        /// NISWITCH_TOPOLOGY_1167_INDEPENDENT 
        /// NISWITCH_TOPOLOGY_1169_100_SPST 
        /// NISWITCH_TOPOLOGY_1190_QUAD_4X1_MUX 
        /// NISWITCH_TOPOLOGY_1191_QUAD_4X1_MUX 
        /// NISWITCH_TOPOLOGY_1192_8_SPDT 
        /// NISWITCH_TOPOLOGY_1193_32X1_MUX 
        /// NISWITCH_TOPOLOGY_1193_16X1_TERMINATED_MUX 
        /// NISWITCH_TOPOLOGY_1193_DUAL_16X1_MUX 
        /// NISWITCH_TOPOLOGY_1193_DUAL_8X1_TERMINATED_MUX 
        /// NISWITCH_TOPOLOGY_1193_QUAD_8X1_MUX 
        /// NISWITCH_TOPOLOGY_1193_QUAD_4X1_TERMINATED_MUX 
        /// NISWITCH_TOPOLOGY_1193_INDEPENDENT 
        /// NISWITCH_TOPOLOGY_2501_1_WIRE_48X1_MUX 
        /// NISWITCH_TOPOLOGY_2501_1_WIRE_48X1_AMPLIFIED_MUX 
        /// NISWITCH_TOPOLOGY_2501_2_WIRE_24X1_MUX 
        /// NISWITCH_TOPOLOGY_2501_2_WIRE_24X1_AMPLIFIED_MUX 
        /// NISWITCH_TOPOLOGY_2501_2_WIRE_DUAL_12X1_MUX 
        /// NISWITCH_TOPOLOGY_2501_2_WIRE_QUAD_6X1_MUX 
        /// NISWITCH_TOPOLOGY_2501_2_WIRE_4X6_MATRIX 
        /// NISWITCH_TOPOLOGY_2501_4_WIRE_12X1_MUX 
        /// NISWITCH_TOPOLOGY_2503_1_WIRE_48X1_MUX 
        /// NISWITCH_TOPOLOGY_2503_2_WIRE_24X1_MUX 
        /// NISWITCH_TOPOLOGY_2503_2_WIRE_DUAL_12X1_MUX 
        /// NISWITCH_TOPOLOGY_2503_2_WIRE_QUAD_6X1_MUX 
        /// NISWITCH_TOPOLOGY_2503_2_WIRE_4X6_MATRIX 
        /// NISWITCH_TOPOLOGY_2503_4_WIRE_12X1_MUX 
        /// NISWITCH_TOPOLOGY_2529_2_WIRE_DUAL_4X16_MATRIX 
        /// NISWITCH_TOPOLOGY_2529_2_WIRE_8X16_MATRIX 
        /// NISWITCH_TOPOLOGY_2529_2_WIRE_4X32_MATRIX 
        /// NISWITCH_TOPOLOGY_2530_1_WIRE_128X1_MUX 
        /// NISWITCH_TOPOLOGY_2530_1_WIRE_4x32_MATRIX 
        /// NISWITCH_TOPOLOGY_2530_1_WIRE_8x16_MATRIX 
        /// NISWITCH_TOPOLOGY_2530_2_WIRE_4x16_MATRIX 
        /// NISWITCH_TOPOLOGY_2530_2_WIRE_64X1_MUX 
        /// NISWITCH_TOPOLOGY_2530_4_WIRE_32X1_MUX 
        /// NISWITCH_TOPOLOGY_2530_INDEPENDENT 
        /// NISWITCH_TOPOLOGY_2532_1_WIRE_4X128_MATRIX 
        /// NISWITCH_TOPOLOGY_2532_1_WIRE_8X64_MATRIX 
        /// NISWITCH_TOPOLOGY_2532_1_WIRE_SIXTEEN_2X16_MATRIX 
        /// NISWITCH_TOPOLOGY_2565_16_SPST 
        /// NISWITCH_TOPOLOGY_2566_16_SPDT 
        /// NISWITCH_TOPOLOGY_2567_INDEPENDENT 
        /// NISWITCH_TOPOLOGY_2568_31_SPST 
        /// NISWITCH_TOPOLOGY_2569_100_SPST 
        /// NISWITCH_TOPOLOGY_2570_40_SPDT 
        /// NISWITCH_TOPOLOGY_2590_4X1_MUX 
        /// NISWITCH_TOPOLOGY_2591_4X1_MUX 
        /// NISWITCH_TOPOLOGY_2593_16X1_MUX 
        /// NISWITCH_TOPOLOGY_2593_8X1_TERMINATED_MUX 
        /// NISWITCH_TOPOLOGY_2593_DUAL_8X1_MUX 
        /// NISWITCH_TOPOLOGY_2593_DUAL_4X1_TERMINATED_MUX 
        /// NISWITCH_TOPOLOGY_2593_INDEPENDENT
        /// </param>
        /// <param name="Simulate">
        /// Enables simulation of the switch module specified in the resource name parameter.
        /// 
        /// Valid Values: 
        /// VI_TRUE - Simulate 
        /// VI_FALSE - Don't Simulate (Default Value)
        /// </param>
        /// <param name="Reset_Device">
        /// Specifies whether to reset the switch module during the initialization process. 
        /// Valid Values: 
        /// VI_TRUE - Reset Device (Default Value) 
        /// VI_FALSE - Currently unsupported. The device will not reset.
        /// </param>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        public niSwitch(string Resource_Name, string Topology, bool Simulate, bool Reset_Device)
        {
            int pInvokeResult = PInvoke.InitWithTopology(Resource_Name, Topology, System.Convert.ToUInt16(Simulate), System.Convert.ToUInt16(Reset_Device), out this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            this._disposed = false;
        }
        
        /// <summary>
        /// Creates a path between channel 1 and channel 2. The driver calculates and uses the shortest path between the two channels. Refer to Immediate Operations for information about Channel Usage types. 
        /// 
        /// If a path is not available, the function returns one of the following errors: 
        /// - NISWITCH_ERROR_EXPLICIT_CONNECTION_EXISTS, if the two channels
        ///   are already explicitly connected by calling either the 
        ///   niSwitch_Connect or niSwitch_SetPath function. 
        ///   
        /// - NISWITCH_ERROR_IS_CONFIGURATION_CHANNEL, if a channel is a
        ///   configuration channel. Error elaboration contains information
        ///   about which of the two channels is a configuration channel. 
        /// 
        /// - NISWITCH_ERROR_ATTEMPT_TO_CONNECT_SOURCES, if both channels
        ///   are connected to a different source. Error elaboration
        ///   contains information about sources channel 1 and 2 connect to.
        /// - NISWITCH_ERROR_CANNOT_CONNECT_TO_ITSELF, if channels 1 and 2
        ///   are one and the same channel. 
        /// - NISWITCH_ERROR_PATH_NOT_FOUND, if the driver cannot find a
        ///   path between the two channels. 
        ///   
        /// Note: Paths are bidirectional. For example, if a path exists between channels CH1 and CH2, then the path also exists between channels CH2 and CH1.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <param name="Channel_1">
        /// Input one of the channel names of the desired path. Pass the other channel name as the channel 2 parameter. Refer to Devices Overview for valid channel names for the switch module.
        /// 
        /// Examples of valid channel names: 
        /// 
        /// ch0, com0, ab0, r1, c2, cjtemp
        /// 
        /// Default value: None 
        /// 
        /// </param>
        /// <param name="Channel_2">
        /// Input one of the channel names of the desired path. Pass the other channel name as the channel 1 parameter. Refer to Devices Overview for valid channel names for the switch module. 
        /// 
        /// Examples of valid channel names: 
        /// 
        /// ch0, com0, ab0, r1, c2, cjtemp
        /// 
        /// Default value: None 
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int Connect(string Channel_1, string Channel_2)
        {
            int pInvokeResult = PInvoke.Connect(this._handle, Channel_1, Channel_2);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function destroys the path between two channels that you create with the niSwitch_Connect or niSwitch_SetPath function.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <param name="Channel_1">
        /// Input one of the channel names of the path to break. Pass the other channel name as the channel 2 parameter. Refer to Devices Overview for valid channel names for the switch module.
        /// 
        /// Examples of valid channel names: 
        /// 
        /// ch0, com0, ab0, r1, c2, cjtemp
        /// 
        /// Default value: None 
        /// 
        /// </param>
        /// <param name="Channel_2">
        /// Input one of the channel names of the path to break. Pass the other channel name as the channel 1 parameter. Refer to Devices Overview for valid channel names for the switch module.
        /// 
        /// Examples of valid channel names: 
        /// 
        /// ch0, com0, ab0, r1, c2, cjtemp
        /// 
        /// Default value: None 
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int Disconnect(string Channel_1, string Channel_2)
        {
            int pInvokeResult = PInvoke.Disconnect(this._handle, Channel_1, Channel_2);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Breaks all existing paths. 
        /// 
        /// If the switch module cannot break all paths, NISWITCH_WARN_PATH_REMAINS warning is returned. 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int DisconnectAll()
        {
            int pInvokeResult = PInvoke.DisconnectAll(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Indicates if all created paths have settled by returning the value of the NISWITCH_ATTR_IS_DEBOUNCED attribute. 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <param name="Is_Debounced">
        /// VI_TRUE indicates that all created paths have settled. VI_FALSE indicates that all created paths have not settled. 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int IsDebounced(out bool Is_Debounced)
        {
            System.UInt16 Is_DebouncedAsUShort;
            int pInvokeResult = PInvoke.IsDebounced(this._handle, out Is_DebouncedAsUShort);
            Is_Debounced = System.Convert.ToBoolean(Is_DebouncedAsUShort);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Pauses until all created paths have settled. 
        /// 
        /// If the time you specify with the Maximum Time (ms) parameter elapsed before the switch paths have settled, this function returns the NISWITCH_ERROR_MAX_TIME_EXCEEDED error.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <param name="Maximum_Time__ms_">
        /// Specifies the maximum length of time to wait for all relays in the switch module to activate or deactivate. If the specified time elapses before all relays active or deactivate, a timeout error is returned.
        /// 
        /// Default Value:5000 ms
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int WaitForDebounce(int Maximum_Time__ms_)
        {
            int pInvokeResult = PInvoke.WaitForDebounce(this._handle, Maximum_Time__ms_);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Verifies that a path between channel 1 and channel 2 can be created. 
        /// 
        /// If a path is possible in the switch module, the availability of that path is returned given the existing connections. If the path is possible but in use, a NISWITCH_WARN_IMPLICIT_CONNECTION_EXISTS warning is returned.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <param name="Channel_1">
        /// Input one of the channel names of the desired path. Pass the other channel name as the channel 2 parameter. Refer to Devices Overview for valid channel names for the switch module.
        /// 
        /// Examples of valid channel names: 
        /// 
        /// ch0, com0, ab0, r1, c2, cjtemp
        /// 
        /// Default value: ""
        /// </param>
        /// <param name="Channel_2">
        /// Input one of the channel names of the desired path. Pass the other channel name as the channel 1 parameter. Refer to Devices Overview for valid channel names for the switch module.
        /// 
        /// Examples of valid channel names: 
        /// 
        /// ch0, com0, ab0, r1, c2, cjtemp
        /// 
        /// Default value: ""
        /// </param>
        /// <param name="Path_Capability">
        /// Indicates whether a path is valid. 
        /// Possible values include: 
        /// ------------------------------------
        /// NISWITCH_VAL_PATH_AVAILABLE        1
        /// NISWITCH_VAL_PATH_EXISTS           2 
        /// NISWITCH_VAL_PATH_UNSUPPORTED      3 
        /// NISWITCH_VAL_RSRC_IN_USE           4 
        /// NISWITCH_VAL_SOURCE_CONFLICT       5 
        /// NISWITCH_VAL_CHANNEL_NOT_AVAILABLE 6 
        /// 
        /// Notes: (1) NISWITCH_VAL_PATH_AVAILABLE indicates that the driver
        ///            can create the path at this time.
        ///        (2) NISWITCH_VAL_PATH_EXISTS   indicates  that  the  path
        ///            already exists. 
        ///        (3) NISWITCH_VAL_PATH_UNSUPPORTED    indicates  that  the
        ///            instrument is not capable of  creating a path between
        ///            the channels you specify. 
        ///        (4) NISWITCH_VAL_RSRC_IN_USE   indicates   that  although
        ///            the path is valid, the driver cannot  create the path
        ///            at this moment because the switch device is currently
        ///            using one or more of the required  channels to create
        ///            another path. You  must destroy the other path before
        ///            creating this one. 
        ///        (5) NISWITCH_VAL_SOURCE_CONFLICT   indicates   that   the
        ///            instrument cannot create a path because both channels
        ///            are connected to a different source channel. 
        ///        (6) NISWITCH_VAL_CHANNEL_NOT_AVAILABLE indicates that the
        ///            driver cannot create a path  between the two channels
        ///            because  one  of  the  channels  is  a  configuration
        ///            channel    and    thus  unavailable   for    external
        ///            connections.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int CanConnect(string Channel_1, string Channel_2, out int Path_Capability)
        {
            int pInvokeResult = PInvoke.CanConnect(this._handle, Channel_1, Channel_2, out Path_Capability);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Connects two channels by specifying an explicit path in the path list parameter. niSwitch_SetPath is particularly useful where path repeatability is important, such as in calibrated signal paths. If this is not necessary, use niSwitch_Connect. 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <param name="Path_List">
        /// A string composed of comma-separated paths between channel 1 and channel 2. The first and last names in the path are the endpoints of the path. Every other channel in the path are configuration channels.
        /// 
        /// Example of a valid path list string:
        /// 
        /// ch0-&gt;com0, com0-&gt;ab0.
        /// 
        /// In this example, com0 is a configuration channel.
        /// 
        /// Default value: None 
        /// 
        /// Obtain the path list for a previously created path with niSwitch_GetPath. 
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int SetPath(string Path_List)
        {
            int pInvokeResult = PInvoke.SetPath(this._handle, Path_List);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns a string that identifies the explicit path created with niSwitch_Connect. Pass this string to niSwitch_SetPath to establish the exact same path in future connections. 
        /// 
        /// In some cases, multiple paths are available between two channels. When you call niSwitch_Connect, the driver selects an available path. With niSwitch_Connect, there is no guarantee that the driver selected path will always be the same path through the switch module.
        /// 
        /// niSwitch_GetPath only returns those paths explicitly created by niSwitch Connect Channels or niSwitch_SetPath. For example, if you connect channels CH1 and CH3,and then channels CH2 and CH3, an explicit path between channels CH1 and CH2 does not exist an error is returned
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <param name="Channel_1">
        /// Input one of the channel names of the desired path. Pass the other channel name as the channel 2 parameter. Refer to Devices Overview for valid channel names for the switch module.
        /// 
        /// Examples of valid channel names: 
        /// 
        /// ch0, com0, ab0, r1, c2, cjtemp
        /// 
        /// Default value: ""
        /// </param>
        /// <param name="Channel_2">
        /// Input one of the channel names of the desired path. Pass the other channel name as the channel 1 parameter. Refer to Devices Overview for valid channel names for the switch module. 
        /// 
        /// Examples of valid channel names: 
        /// 
        /// ch0, com0, ab0, r1, c2, cjtemp
        /// 
        /// Default value: ""
        /// </param>
        /// <param name="Buffer_Size">
        /// Pass the number of bytes in the ViChar array you specify for the Path List parameter. If the current value of the attribute, including the terminating NULL byte, contains more bytes that you indicate in this parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NULL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "R1-&gt;C1" and the Buffer Size is 4, the function places "R1-" into the buffer and returns 7. If you pass 0, you can pass VI_NULL for the Path parameter. This enables you to find out the path size and to allocate the buffer of the appropriate size before calling this function again.
        /// </param>
        /// <param name="Path">
        /// A string composed of comma-separated paths between channel 1 and channel 2. The first and last names in the path are the endpoints of the path. All other channels in the path are configuration channels.
        /// 
        /// Examples of returned paths:
        /// 
        /// ch0-&gt;com0, com0-&gt;ab0 
        /// 
        /// </param>
        /// <returns>
        /// Contains the status code that the function call returns. If the function succeeds and the buffer you pass is large enough to hold the entire value, the function returns VI_SUCCESS. If the current value of the attribute, including the terminating NULL byte, is larger than the size you indicate in the Buffer Size parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NULL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. 
        /// Negative values indicate an error. You examine the status code from each call to an instrument driver function to determine if an error occurred. To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int GetPath(string Channel_1, string Channel_2, int Buffer_Size, System.Text.StringBuilder Path)
        {
            int pInvokeResult = PInvoke.GetPath(this._handle, Channel_1, Channel_2, Buffer_Size, Path);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function is a high level operation for scanning. It takes the scan list provided, programs the switching hardware and initiates the scan. Once initiation is complete, the operation will return. The scan list itself is comprised of a list of channel connections separated by semicolons. 
        /// 
        /// For example, the following scan list would scan the first three channels of a multiplexer. 
        /// 
        /// Example: com0-&gt;ch0; com0-&gt;ch1; com0-&gt;ch2; 
        /// 
        /// For more information on scan list syntax, refer to the NI Switches Help. To see the status of the scan, you can call either niSwitch_IsScanning or niSwitch_WaitForScanComplete. Use the niSwitch_ConfigureScanTrigger function to configure the scan trigger. Use the niSwitch_AbortScan function to stop the scan if you are in continuous scan mode (Refer to niSwitch_SetContinuousScan); otherwise the scan halts automatically when the end of the scan list is reached. For reference, this operation is equivalent to calling niSwitch_ConfigureScanList and niSwitch_InitiateScan.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <param name="Scanlist">
        /// Pass the scan list you want the instrument to use. 
        /// The driver uses this value to set the NISWITCH_ATTR_SCAN_LIST attribute. The scan list is a string that specifies channel connections and trigger conditions for scanning. After you call the niSwitch_InitiateScan function, the instrument makes or breaks connections and waits for triggers according to the instructions in the scan list. The scan list is comprised of channel names that you separate with special characters. These special characters determine the operation the scanner performs on the channels when it executes this scan list. 
        /// 
        /// To create a path between two channels, use '-&gt;' (a dash followed by a '&gt;' sign) between the two channel names. 
        /// 
        /// Example: 
        /// "CH1-&gt;CH2" instructs the switch to make a path from channel
        ///               CH1 to channel CH2. 
        /// 
        /// To break or clear a path, use a '~' (tilde) as a prefix before the path. 
        /// 
        /// Example: 
        /// "~CH1-&gt;CH2" instructs the switch to break the path from
        ///                channel CH1 to channel CH2. 
        /// 
        /// To wait for a trigger event, use a ';' (semicolon) as a separator between paths. 
        /// 
        /// Example: 
        /// "CH1-&gt;CH2;CH3-&gt;CH4" instructs the switch to make the path
        ///                           from channel CH1 to channel CH2, wait
        ///                           for a trigger, and then make the path
        ///                           from CH3 to CH4. 
        /// 
        /// To tell the switch device to create multiple paths simultaneously, use an '&amp;' (ampersand) character as a separator between the paths. 
        /// 
        /// Example: 
        /// "CH0-&gt;CH1; CH1-&gt;CH2 &amp; CH3-&gt;CH4" instructs the
        ///          scanner to make the path between channels CH0 and CH1,
        ///          wait for a trigger, and then simultaneously make the
        ///          paths between channels CH1 and CH2 and between channels
        ///          CH3 and CH4. 
        ///          
        /// For SCXI use the following syntax : 
        /// - For a single channel: sc&lt;chassis ID number&gt;!md&lt;module slot number&gt;!ch&lt;channel number&gt; -&gt; com0; 
        /// 
        /// For example: for Chassis 1, module in slot 3, and ch 30 the syntax is: 
        /// sc1!md3!ch30 -&gt;com0; 
        /// 
        /// For multiple sequential channels: 
        /// sc&lt;chassis ID number&gt;!md&lt;module slot number&gt;!ch&lt;channel number to start with: channel number to end with&gt; -&gt; com0; 
        /// 
        /// For example: for Chassis 1, module in slot 3, and ch 30 to 19 the syntax is: 
        /// sc1!md3!ch30:19 -&gt;com0; will scan from channel 30 to 19 sequentially. 
        /// 
        /// For multiple randomly ordered channels: sc&lt;chassis ID number&gt;!md&lt;module slot number&gt;!ch&lt;channel number&gt; -&gt; com0; sc&lt;chassis ID number&gt;!md&lt;next module slot number&gt;!ch&lt;next channel number&gt; -&gt; com0; 
        /// 
        /// For example: for Chassis 1, module in slot 3 and slot 4, and ch 30 and 5 on slot 3 and channel 19 on slot 4the syntax is: 
        /// sc1!md3!ch30 -&gt;com0; sc1!md4!ch19 -&gt;com0; sc1!md3!ch5 -&gt;com0; 
        /// 
        /// This will scan ch30 of slot 3 then ch19 of slot 4 then ch5 of slot3. 
        /// 
        /// For more information on scan list syntax, refer to the NI Switches Help. 
        /// 
        /// Default Value: None
        /// </param>
        /// <param name="Initiation">
        /// Use the initiation paramater to specify whether the switch device or the measurement device will be initiating the scan trigger handshake. This parameter determines whether to wait for the scan to reach a trigger point before completing. 
        /// If the Measurement Device will initiate the scan, set this parameter to NISWITCH_VAL_MEASUREMENT_DEVICE_INITIATED. This function will then wait until the switch is waiting for a trigger from the measurement device before completing. 
        /// If the Switch will initiate the scan, set this parameter to NISWITCH_VAL_SWITCH_INITIATED. This function will then complete immediately after initating the scan. 
        /// You should have already set up your DMM to wait for a trigger before calling this function with Initiation set to NISWITCH_VAL_SWITCH_INITIATED.
        /// 
        /// Valid values: 
        /// NISWITCH_VAL_SWITCH_INITIATED             - Switch Initiated
        /// NISWITCH_VAL_MEASUREMENT_DEVICE_INITIATED - Measurement device 
        ///                                             initiated
        /// 
        /// Default value: NISWITCH_VAL_MEASUREMENT_DEVICE_INITIATED
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int Scan(string Scanlist, short Initiation)
        {
            int pInvokeResult = PInvoke.Scan(this._handle, Scanlist, Initiation);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Commits the configured scan list and trigger settings to hardware and initiates the scan. If niSwitch Commit was called earlier, niSwitch Initiate Scan only initiates the scan and returns immediately. 
        /// 
        /// Once the scanning operation begins, you cannot perform any other operation other than GetAttribute, AbortScan, or SendSoftwareTrigger. All other functions return NISWITCH_ERROR_SCAN_IN_PROGRESS. To stop the scanning operation, 
        /// 
        /// To stop the scanning operation, call niSwitch_AbortScan.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int InitiateScan()
        {
            int pInvokeResult = PInvoke.InitiateScan(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Aborts the scan in progress. 
        /// 
        /// Initiate a scan with niSwitch_InitiateScan.
        /// 
        /// If the switch module is not scanning,  NISWITCH_ERROR_NO_SCAN_IN_PROGRESS error is returned.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int AbortScan()
        {
            int pInvokeResult = PInvoke.AbortScan(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Sends a software trigger to the switch module specified in the NI-SWITCH session. When the trigger input is set to NISWITCH_VAL_SOFTWARE_TRIG through either the niSwitch_ConfigureScanTrigger or the NISWITCH_ATTR_TRIGGER_INPUT attribute, the scan does not proceed from a semi-colon (wait for trigger) until niSwitch_SendSoftwareTrigger is called. 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int SendSoftwareTrigger()
        {
            int pInvokeResult = PInvoke.SendSoftwareTrigger(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Indicates the status of the scan. 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <param name="Is_Scanning">
        /// The driver returns the value of NISWITCH_ATTR_IS_SCANNING attribute. VI_TRUE indicates that the switch device is scanning. VI_FALSE indicates that the switch device is idle.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int IsScanning(out bool Is_Scanning)
        {
            System.UInt16 Is_ScanningAsUShort;
            int pInvokeResult = PInvoke.IsScanning(this._handle, out Is_ScanningAsUShort);
            Is_Scanning = System.Convert.ToBoolean(Is_ScanningAsUShort);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Pauses until the switch module stops scanning or the maximum time has elapsed and returns a timeout error. 
        /// 
        /// If the time you specify with the Maximum Time (ms) parameter elapsed before the scanning operation has finished, this function returns the NISWITCH_ERROR_MAX_TIME_EXCEEDED error.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <param name="Maximum_Time__ms_">
        /// Specifies the maximum length of time to wait for the switch module to stop scanning. If the specified time elapses before the scan ends, NISWITCH_ERROR_MAX_TIME_EXCEEDED error is returned.
        /// 
        /// Default Value:5000 ms
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int WaitForScanComplete(int Maximum_Time__ms_)
        {
            int pInvokeResult = PInvoke.WaitForScanComplete(this._handle, Maximum_Time__ms_);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Sets the to loop continuously through the scan list or to stop scanning after one pass through the scan list. 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <param name="Continuous_Scan">
        /// If VI_TRUE, loops continuously through the scan list during scanning. If VI_FALSE, the scan stops after one pass through the scan list.
        /// 
        /// Default value: VI_FALSE 
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int SetContinuousScan(bool Continuous_Scan)
        {
            int pInvokeResult = PInvoke.SetContinuousScan(this._handle, System.Convert.ToUInt16(Continuous_Scan));
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Configures the scan list and scan mode used for scanning. 
        /// 
        /// Refer to Devices Overview to determine if the switch module supports scanning.
        /// 
        /// The scan list is comprised of a list of channel connections separated by semi-colons. For example, the following scan list will scan the first three channels of a multiplexer:
        /// 
        /// com0-&gt;ch0; com0-&gt;ch1; com0-&gt;ch2;
        /// 
        /// Refer to Scan Lists for more information on scan list syntax
        /// 
        /// To see the status of the scan, call either niSwitch_IsScanning or niSwitch_WaitForScanComplete. Use the niSwitch_ConfigureScanTrigger function to configure the scan trigger. Use the niSwitch_InitiateScan function to start the scan.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <param name="Scanlist">
        /// The scan list to use. The driver uses this value to set the Scan List attribute.
        /// 
        /// Default value: None 
        /// 
        /// </param>
        /// <param name="Scan_Mode">
        /// Specifies how the switch module breaks existing connections when scanning. The driver uses this value to set the Scan Mode attribute. Refer to scan modes for more information.
        /// 
        /// Default value: Break Before Make 
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int ConfigureScanList(string Scanlist, int Scan_Mode)
        {
            int pInvokeResult = PInvoke.ConfigureScanList(this._handle, Scanlist, Scan_Mode);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Configures the scan triggers for the scan list established with niSwitch_ConfigureScanList. 
        /// 
        /// Refer to Devices Overview to determine if the switch module supports scanning.
        /// 
        /// niSwitch_ConfigureScanTrigger sets the location that the switch expects to receive an input trigger to advance through the scan list. This function also sets the location where it outputs a scan advanced signal after it completes an entry in the scan list.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <param name="Scan_Delay">
        /// The minimum length of time you want the switch device to wait after it creates a path until it asserts a trigger on the scan advanced output line. The driver uses this value to set the Scan Delay attribute. The scan delay is in addition to the settling time.The driver uses this value to set the NISWITCH_ATTR_SCAN_DELAY attribute. 
        /// 
        /// Express this value in seconds. 
        /// 
        /// Default value: 0.0 s
        /// </param>
        /// <param name="Trigger_Input">
        /// Trigger source you want the switch module to use during scanning. The driver uses this value to set the NISWITCH_ATTR_TRIGGER_INPUT attribute. The switch device waits for the trigger you specify when it encounters a semicolon in the scanlist. When the trigger occurs, the switch device advances to the next entry in the scanlist. Refer to the NISWITCH_ATTR_TRIGGER_INPUT topic in the NI Switches Help for a list of valid values.
        /// 
        /// 
        /// </param>
        /// <param name="Scan_Advanced_Output">
        /// Output destination of the scan advanced trigger signal. The driver uses this value to set the NISWITCH_ATTR_SCAN_ADVANCED_OUTPUT attribute. After the switch processes each entry in the scan list, it waits the length of time you specify in the Scan Delay parameter and then asserts a trigger on the line you specify with this parameter. Refer to the NISWITCH_ATTR_SCAN_ADVANCED_OUTPUT topic in the NI Switches Help for a list of valid values.
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int ConfigureScanTrigger(System.Double Scan_Delay, int Trigger_Input, int Scan_Advanced_Output)
        {
            int pInvokeResult = PInvoke.ConfigureScanTrigger(this._handle, Scan_Delay, Trigger_Input, Scan_Advanced_Output);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Routes the input trigger from the front or rear connector to a trigger bus line (TTLx). To disconnect the route, call this function again and specify None for trigger bus line parameter. 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <param name="Trigger_Input_Connector">
        /// The location of the input trigger source on the switch module. Valid locations are the NISWITCH_VAL_FRONTCONNECTOR and NISWITCH_VAL_REARCONNECTOR.
        /// 
        /// Default value: NISWITCH_VAL_FRONTCONNECTOR
        /// 
        /// </param>
        /// <param name="Trigger_Input_Bus_Line">
        /// The trigger line to route the input trigger. Select NISWITCH_VAL_NONE to break an existing route.
        /// 
        /// Default value: None 
        /// 
        /// Valid Values:
        /// 
        /// NISWITCH_VAL_NONE
        /// NISWITCH_VAL_TTL0
        /// NISWITCH_VAL_TTL1
        /// NISWITCH_VAL_TTL2
        /// NISWITCH_VAL_TTL3
        /// NISWITCH_VAL_TTL4
        /// NISWITCH_VAL_TTL5
        /// NISWITCH_VAL_TTL6
        /// NISWITCH_VAL_TTL7
        /// 
        /// 
        /// </param>
        /// <param name="Invert">
        /// If VI_TRUE, inverts the input trigger signal from falling to rising or vice versa.
        /// 
        /// Default value: VI_FALSE 
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int RouteTriggerInput(int Trigger_Input_Connector, int Trigger_Input_Bus_Line, bool Invert)
        {
            int pInvokeResult = PInvoke.RouteTriggerInput(this._handle, Trigger_Input_Connector, Trigger_Input_Bus_Line, System.Convert.ToUInt16(Invert));
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Routes the scan advanced output trigger from a trigger bus line (TTLx) to the front or rear connector. 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <param name="Scan_Advanced_Output_Connector">
        /// The scan advanced trigger destination. Valid locations are the NISWITCH_VAL_FRONTCONNECTOR and NISWITCH_VAL_REARCONNECTOR.
        /// 
        /// Default value: NISWITCH_VAL_FRONTCONNECTOR
        /// 
        /// </param>
        /// <param name="Scan_Advanced_Output_Bus_Line">
        /// The trigger line to route the scan advanced output trigger from the front or rear connector. Select NISWITCH_VAL_NONE to break an existing route.
        /// 
        /// Default value: None 
        /// 
        /// Valid Values:
        /// 
        /// NISWITCH_VAL_NONE
        /// NISWITCH_VAL_TTL0
        /// NISWITCH_VAL_TTL1
        /// NISWITCH_VAL_TTL2
        /// NISWITCH_VAL_TTL3
        /// NISWITCH_VAL_TTL4
        /// NISWITCH_VAL_TTL5
        /// NISWITCH_VAL_TTL6
        /// NISWITCH_VAL_TTL7
        /// </param>
        /// <param name="Invert">
        /// If VI_TRUE, inverts the input trigger signal from falling to rising or vice versa.
        /// 
        /// Default value: VI_FALSE 
        /// 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int RouteScanAdvancedOutput(int Scan_Advanced_Output_Connector, int Scan_Advanced_Output_Bus_Line, bool Invert)
        {
            int pInvokeResult = PInvoke.RouteScanAdvancedOutput(this._handle, Scan_Advanced_Output_Connector, Scan_Advanced_Output_Bus_Line, System.Convert.ToUInt16(Invert));
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the relay name string that is in the relay list at the specified index. 
        /// 
        /// Use niSwitch_GetRelayName in a For Loop to get a complete list of valid relay names for the switch module. Use the Number of Relays attribute to determine the number of relays. 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <param name="Index">
        /// A 1-based index into the channel table.
        /// 
        /// Default value: 1
        /// 
        /// Maximum value: Value of Channel Count attribute. 
        /// 
        /// </param>
        /// <param name="Relay_Name_Buffer_Size">
        /// Pass the number of bytes in the ViChar array you specify for the Relay Name Buffer parameter. If the relay name string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value. If you pass 0, you can pass VI_NULL for the Coercion Record buffer parameter. Default Value: None
        /// </param>
        /// <param name="Relay_Name_Buffer">
        /// Returns the relay name for the index you specify.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. If the current value of the return buffer, including the terminating NUL byte, is larger than the size you indicate in the Buffer Size parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. 
        /// 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int GetRelayName(int Index, int Relay_Name_Buffer_Size, System.Text.StringBuilder Relay_Name_Buffer)
        {
            int pInvokeResult = PInvoke.GetRelayName(this._handle, Index, Relay_Name_Buffer_Size, Relay_Name_Buffer);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the number of times the relay has changed from Closed to Open. Relay count is useful for tracking relay lifetime and usage. Call niSwitch_WaitForDebounce before niSwitch_GetRelayCount to ensure an accurate count.
        /// 
        /// Refer to Devices Overview of the NI Switches Help to determine if the switch module supports individual relay control.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <param name="Relay_Name">
        /// Name of the relay.
        /// 
        /// Default value: None
        /// 
        /// Examples of valid relay names:
        /// 
        /// ch0, ab0, 1wire, hlselect 
        /// 
        /// Refer to Devices Overview for a list of valid relay names for the switch module.
        /// 
        /// </param>
        /// <param name="Relay_Count">
        /// The number of relay cycles. 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int GetRelayCount(string Relay_Name, out int Relay_Count)
        {
            int pInvokeResult = PInvoke.GetRelayCount(this._handle, Relay_Name, out Relay_Count);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the relay position for the relay specified in the Relay Name parameter.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <param name="Relay_Name">
        /// Name of the relay.
        /// 
        /// Default value: None
        /// 
        /// Examples of valid relay names:
        /// 
        /// ch0, ab0, 1wire, hlselect 
        /// 
        /// Refer to Devices Overview for a list of valid relay names for the switch module.
        /// 
        /// </param>
        /// <param name="Relay_Position">
        /// Indicates whether the relay is open or closed. 
        /// 
        /// NISWITCH_VAL_OPEN       10
        /// NIWITCH_VAL_CLOSED      11 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int GetRelayPosition(string Relay_Name, out int Relay_Position)
        {
            int pInvokeResult = PInvoke.GetRelayPosition(this._handle, Relay_Name, out Relay_Position);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Controls individual relays of the switch module. When controlling individual relays, the protection offered by setting the usage of source channels and configurations channels is void. 
        /// 
        /// Refer to Devices Overview to determine if the switch module supports individual relay control. 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <param name="Relay_Name">
        /// Name of the relay.
        /// 
        /// Default value: None
        /// 
        /// Examples of valid relay names:
        /// 
        /// ch0, ab0, 1wire, hlselect 
        /// 
        /// Refer to Devices Overview for a list of valid relay names for the switch module.
        /// 
        /// </param>
        /// <param name="Relay_Action">
        /// Specifies whether to open or close a given relay.
        /// 
        /// Default value: Relay Close 
        /// 
        /// Defined values:
        /// NISWITCH_VAL_OPEN_RELAY
        /// NISWITCH_VAL_CLOSE_RELAY (Default Value)
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int RelayControl(string Relay_Name, int Relay_Action)
        {
            int pInvokeResult = PInvoke.RelayControl(this._handle, Relay_Name, Relay_Action);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Downloads the configured scan list and trigger settings to hardware. 
        /// 
        /// Calling niSwitch_Commit optional as it is implicitly called during niSwitch_InitiateScan. Use niSwitch_Commit to arm triggers in a given order or to control when expensive hardware operations are performed. 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int Commit()
        {
            int pInvokeResult = PInvoke.Commit(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the channel string that is in the channel table at the specified index. 
        /// 
        /// Use niSwitch_GetChannelName in a For Loop to get a complete list of valid channel names for the switch module. Use the Channel Count attribute to determine the number of channels. 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <param name="Index">
        /// A 1-based index into the channel table.
        /// 
        /// Default value: 1
        /// 
        /// Maximum value: Value of Channel Count attribute. 
        /// 
        /// </param>
        /// <param name="Buffer_Size">
        /// Pass the number of bytes in the ViChar array you specify for the Channel Name Buffer parameter. If the channel name string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value. If you pass 0, you can pass VI_NULL for the Coercion Record buffer parameter. Default Value: None
        /// </param>
        /// <param name="Channel_Name_Buffer">
        /// Returns the channel name that is in the channel table at the index you specify.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. If the current value of the return buffer, including the terminating NUL byte, is larger than the size you indicate in the Buffer Size parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. 
        /// 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int GetChannelName(int Index, int Buffer_Size, System.Text.StringBuilder Channel_Name_Buffer)
        {
            int pInvokeResult = PInvoke.GetChannelName(this._handle, Index, Buffer_Size, Channel_Name_Buffer);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Disconnects all created paths and returns the switch module to the state at initialization. Configuration channel and source channel settings remain unchanged. 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int reset()
        {
            int pInvokeResult = PInvoke.reset(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Resets the switch module and applies initial user specified settings from the logical name used to initialize the session. If the session was created without a logical name, this function is equivalent to niSwitch_reset. 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int ResetWithDefaults()
        {
            int pInvokeResult = PInvoke.ResetWithDefaults(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Places the switch module in a quiescent state where it has minimal or no impact on the system to which it is connected. All channels are disconnected and any scan in progress is aborted. 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int Disable()
        {
            int pInvokeResult = PInvoke.Disable(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Verifies that the driver can communicate with the switch module.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <param name="Self_Test_Result">
        /// Value returned from the switch device self-test. 
        /// 
        /// Passed   0
        /// Failed   1
        /// </param>
        /// <param name="Self_Test_Message">
        /// Self-test response string from the switch device.  You must pass a ViChar array with at least 256 bytes.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int self_test(out short Self_Test_Result, System.Text.StringBuilder Self_Test_Message)
        {
            int pInvokeResult = PInvoke.self_test(this._handle, out Self_Test_Result, Self_Test_Message);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the revision of the NI-SWITCH driver. 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <param name="Instrument_Driver_Revision">
        /// NI-SWITCH software revision numbers in the form of a string.  You must pass a ViChar array with at least 256 bytes.
        /// </param>
        /// <param name="Firmware_Revision">
        /// Currently unsupported. 
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int revision_query(System.Text.StringBuilder Instrument_Driver_Revision, System.Text.StringBuilder Firmware_Revision)
        {
            int pInvokeResult = PInvoke.revision_query(this._handle, Instrument_Driver_Revision, Firmware_Revision);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function reads an error code and a message from the instrument's error queue.
        /// NI-SWITCH does not have an error queue, so this function never returns any errors.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <param name="Error_Code">
        /// Returns the error code read from the instrument's error queue.
        /// NI-SWITCH does not have an error queue, so this function never returns any errors.
        /// </param>
        /// <param name="Error_Message">
        /// Returns the error message string read from the instrument's error message queue. You must pass a ViChar array with at least 256 bytes.
        /// NI-SWITCH does not have an error queue, so this function never returns anything other than "No error".
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int error_query(out int Error_Code, System.Text.StringBuilder Error_Message)
        {
            int pInvokeResult = PInvoke.error_query(this._handle, out Error_Code, Error_Message);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function returns the coercion information associated with the IVI session. This function retrieves and clears the oldest instance in which the instrument driver coerced a value you specified to another value. 
        ///                      
        /// If you set the NISWITCH_ATTR_RECORD_COERCIONS attribute to VI_TRUE, the instrument driver keeps a list of all coercions it makes on ViInt32 or ViReal64 values you pass to instrument driver functions. You use this function to retrieve information from that list. If the next coercion record string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value. If you pass 0, you can pass VI_NULL for the Coercion Record buffer parameter. The function returns an empty string in the Coercion Record parameter if no coercion records remain for the session.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <param name="Buffer_Size">
        /// Pass the number of bytes in the ViChar array you specify for the Coercion Record parameter. 
        /// If the next coercion record string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value. If you pass 0, you can pass VI_NULL for the Coercion Record buffer parameter. Default Value: None
        /// </param>
        /// <param name="Coercion_Record">
        /// Returns the next coercion record for the IVI session. If there are no coercion records, the function returns an empty string. The buffer must contain at least as many elements as the value you specify with the Buffer Size parameter. 
        /// If the next coercion record string, including the terminating NUL byte, contains more bytes than you indicate with the Buffer Size parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. This parameter returns an empty string if no coercion records remain for the session.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. If the current value of the return buffer, including the terminating NUL byte, is larger than the size you indicate in the Buffer Size parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. 
        /// 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int GetNextCoercionRecord(int Buffer_Size, System.Text.StringBuilder Coercion_Record)
        {
            int pInvokeResult = PInvoke.GetNextCoercionRecord(this._handle, Buffer_Size, Coercion_Record);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function returns the interchangeability warnings associated with the IVI session. It retrieves and clears the oldest instance in which the class driver recorded an interchangeability warning. Interchangeability warnings indicate that using your application with a different instrument might cause different behavior. You use this function to retrieve interchangeability warnings. The driver performs interchangeability checking when the NISWITCH_ATTR_INTERCHANGE_CHECK attribute is set to VI_TRUE. The function returns an empty string in the Interchange Warning parameter if no interchangeability warnings remain for the session. In general, the instrument driver generates interchangeability warnings when an attribute that affects the behavior of the instrument is in a state that you did not specify.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <param name="Buffer_Size">
        /// Pass the number of bytes in the ViChar array you specify for the Interchange Warning parameter. 
        /// If the next interchangeability warning string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value. If you pass 0, you can pass VI_NULL for the Interchange Warning buffer parameter. Default Value: None
        /// </param>
        /// <param name="Interchange_Warning">
        /// Returns the next interchange warning for the IVI session. If there are no interchange warnings, the function returns an empty string. The buffer must contain at least as many elements as the value you specify with the Buffer Size parameter. 
        /// If the next interchangeability warning string, including the terminating NUL byte, contains more bytes than you indicate with the Buffer Size parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. This parameter returns an empty string if no interchangeability warnings remain for the session.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. If the current value of the return buffer, including the terminating NUL byte, is larger than the size you indicate in the Buffer Size parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. 
        /// 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int GetNextInterchangeWarning(int Buffer_Size, System.Text.StringBuilder Interchange_Warning)
        {
            int pInvokeResult = PInvoke.GetNextInterchangeWarning(this._handle, Buffer_Size, Interchange_Warning);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function clears the list of current interchange warnings.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int ClearInterchangeWarnings()
        {
            int pInvokeResult = PInvoke.ClearInterchangeWarnings(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// When developing a complex test system that consists of multiple test modules, it is generally a good idea to design the test modules so that they can run in any order. To do so requires ensuring that each test module completely configures the state of each instrument it uses. If a particular test module does not completely configure the state of an instrument, the state of the instrument depends on the configuration from a previously executed test module. If you execute the test modules in a different order, the behavior of the instrument and therefore the entire test module is likely to change. This change in behavior is generally instrument specific and represents an interchangeability problem. 
        /// 
        /// You can use this function to test for such cases. After you call this function, the interchangeability checking algorithms in the specific driver ignore all previous configuration operations. By calling this function at the beginning of a test module, you can determine whether the test module has dependencies on the operation of previously executed test modules. This function does not clear the interchangeability warnings from the list of previously recorded interchangeability warnings. If you want to guarantee that the niSwitch_GetNextInterchangeWarning function only returns those interchangeability warnings that are generated after calling this function, you must clear the list of interchangeability warnings. You can clear the interchangeability warnings list by repeatedly calling the niSwitch_GetNextInterchangeWarning function until no more interchangeability warnings are returned. If you are not interested in the content of those warnings, you can call the niSwitch_ClearInterchangeWarnings function.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
        /// </param>
        /// <returns>
        /// Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
        /// To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
        /// The general meaning of the status code is as follows: 
        /// Value    Meaning 
        /// ------------------------------- 
        /// 0        Success 
        /// Positive Values Warnings 
        /// Negative Values Errors 
        /// 
        /// This driver defines the following status codes: 
        /// Status    Description 
        /// ------------------------------------------------- 
        /// BFFA4001  Another process has already opened a session to this
        ///           switch module.
        /// BFFA4002  Invalid Resource Name or Instrument Descriptor
        /// BFFA4003  You have set an attribute or called a function that is
        ///           only used for scanning, and  this  switch  module does
        ///           not support scanning (or this module does not support
        ///           scanning in the current configuration).
        /// BFFA4004  You have indicated that a non-cabled module should 
        ///           get its trigger from the rear connector, and the
        ///           niSwitch software could not automatically detect
        ///           which cabled module to route the trigger from. Be 
        ///           more specific (ie, specify Rear Connector of Module
        ///           X).
        /// BFFA4005  The scanlist command  exceeds the size of  memory  on
        ///           the switch module.
        /// BFFA4006  Error communicating  with  hardware. Internal timeout
        ///           occurred waiting for hardware response.
        /// BFFA4007  Expecting trigger or scan advanced  bus  to be one of
        ///           the TTL lines (TTL0-TTL7).
        /// BFFA4008  This module requires scan mode to be BreakBeforeMake
        /// BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
        ///           use the TTL1 line. Use a different line,or power down
        ///           the chassis and remove all 1127 modules from it.
        /// BFFA400B  The driver setup string is invalid.
        /// BFFA400C  No legacy device supports the specified topology. Use
        ///           a different  topology, or configure the  device under
        ///           DAQmx and use the DAQmx resource descriptor.
        /// BFFA400D  The specified topology string is invalid.
        /// BFFA400E  The device  was  unexpectedly power cycled. Close and
        ///           re-open the session.
        /// BFFA400F  The values  for  Handshaking Initiation  and  Trigger
        ///           Input are incompatible. An Immediate Trigger Input is
        ///           not compatible  with Measurement Device Initiated (or
        ///           DMM Initiated) Handshaking Initiation.
        /// BFFA4010  A legacy  resource descriptor  was specified, but the
        ///           driver setup string specifies a DAQmx resource type.
        /// BFFA4011  A  DAQmx  resource descriptor was specified,  but the
        ///           driver setup string specifies a Legacy resource type.
        /// BFFA4012  Model code  specified in the  driver  setup string is
        ///           ambiguous.Multiple switches match the specified model
        ///           code.
        /// BFFA4013  The  trigger input you  specified is not supported by
        ///           the device.
        /// 
        /// 
        /// This instrument driver also returns errors and warnings defined by other sources. 
        /// The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
        /// Numeric Range (in Hex) Status Code Types 
        /// ------------------------------------------------- 
        /// 3FFA2000 to 3FFA3FFF IviSwtch Warnings 
        /// 3FFA0000 to 3FFA1FFF IVI Warnings 
        /// 3FFF0000 to 3FFFFFFF VISA Warnings 
        /// 3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
        /// 3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
        /// 3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
        /// 3FFA6400 to 3FFA67FF NI-PAL Warnings
        /// 
        /// BFFA2000 to BFFA3FFF IviSwtch Errors 
        /// BFFA0000 to BFFA1FFF IVI Errors 
        /// BFFF0000 to BFFFFFFF VISA Errors 
        /// BFFC0000 to BFFCFFFF VXIPnP Driver Errors
        /// BFFA4800 to BFFA4BFF NI-DAQmx Errors
        /// BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
        /// BFFA6400 to BFFA67FF NI-PAL Errors
        /// </returns>
        public int ResetInterchangeCheck()
        {
            int pInvokeResult = PInvoke.ResetInterchangeCheck(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        public void Dispose()
        {
            this.Dispose(true);
            System.GC.SuppressFinalize(this);
        }
        
        private void Dispose(bool disposing)
        {
            if ((this._disposed == false))
            {
                PInvoke.close(this._handle);
                this._handle = System.IntPtr.Zero;
            }
            this._disposed = true;
        }
        
        public void SetInt32(niSwitchProperties propertyId, string repeatedCapabilityOrChannel, int val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViInt32(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), val));
        }
        
        public void SetInt32(niSwitchProperties propertyId, int val)
        {
            this.SetInt32(propertyId, "", val);
        }
        
        public int GetInt32(niSwitchProperties propertyId, string repeatedCapabilityOrChannel)
        {
            int val;
            PInvoke.TestForError(this._handle, PInvoke.GetAttributeViInt32(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), out val));
            return val;
        }
        
        public int GetInt32(niSwitchProperties propertyId)
        {
            return this.GetInt32(propertyId, "");
        }
        
        public void SetDouble(niSwitchProperties propertyId, string repeatedCapabilityOrChannel, System.Double val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViReal64(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), val));
        }
        
        public void SetDouble(niSwitchProperties propertyId, System.Double val)
        {
            this.SetDouble(propertyId, "", val);
        }
        
        public System.Double GetDouble(niSwitchProperties propertyId, string repeatedCapabilityOrChannel)
        {
            System.Double val;
            PInvoke.TestForError(this._handle, PInvoke.GetAttributeViReal64(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), out val));
            return val;
        }
        
        public System.Double GetDouble(niSwitchProperties propertyId)
        {
            return this.GetDouble(propertyId, "");
        }
        
        public void SetBoolean(niSwitchProperties propertyId, string repeatedCapabilityOrChannel, bool val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViBoolean(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), System.Convert.ToUInt16(val)));
        }
        
        public void SetBoolean(niSwitchProperties propertyId, bool val)
        {
            this.SetBoolean(propertyId, "", val);
        }
        
        public bool GetBoolean(niSwitchProperties propertyId, string repeatedCapabilityOrChannel)
        {
            System.UInt16 val;
            PInvoke.TestForError(this._handle, PInvoke.GetAttributeViBoolean(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), out val));
            return System.Convert.ToBoolean(val);
        }
        
        public bool GetBoolean(niSwitchProperties propertyId)
        {
            return this.GetBoolean(propertyId, "");
        }
        
        public void SetString(niSwitchProperties propertyId, string repeatedCapabilityOrChannel, string val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViString(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), val));
        }
        
        public void SetString(niSwitchProperties propertyId, string val)
        {
            this.SetString(propertyId, "", val);
        }
        
        public string GetString(niSwitchProperties propertyId, string repeatedCapabilityOrChannel)
        {
            System.Text.StringBuilder newVal = new System.Text.StringBuilder(512);
            int size = PInvoke.GetAttributeViString(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), 512, newVal);
            if ((size < 0))
            {
                PInvoke.ThrowError(this._handle, size);
            }
            else
            {
                if ((size > 0))
                {
                    newVal.Capacity = size;
                    PInvoke.TestForError(this._handle, PInvoke.GetAttributeViString(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), size, newVal));
                }
            }
            return newVal.ToString();
        }
        
        public string GetString(niSwitchProperties propertyId)
        {
            return this.GetString(propertyId, "");
        }
        
        private class PInvoke
        {
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_init",CallingConvention=CallingConvention.StdCall)]
            public static extern int init (string Resource_Name, System.UInt16 ID_Query, System.UInt16 Reset_Device, out System.IntPtr Instrument_Handle);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_InitWithOptions",CallingConvention=CallingConvention.StdCall)]
            public static extern int InitWithOptions (string Resource_Name, System.UInt16 ID_Query, System.UInt16 Reset_Device, string Options_String, out System.IntPtr Instrument_Handle);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_InitWithTopology",CallingConvention=CallingConvention.StdCall)]
            public static extern int InitWithTopology (string Resource_Name, string Topology, System.UInt16 Simulate, System.UInt16 Reset_Device, out System.IntPtr Instrument_Handle);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_Connect",CallingConvention=CallingConvention.StdCall)]
            public static extern int Connect (System.IntPtr Instrument_Handle, string Channel_1, string Channel_2);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_Disconnect",CallingConvention=CallingConvention.StdCall)]
            public static extern int Disconnect (System.IntPtr Instrument_Handle, string Channel_1, string Channel_2);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_DisconnectAll",CallingConvention=CallingConvention.StdCall)]
            public static extern int DisconnectAll (System.IntPtr Instrument_Handle);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_IsDebounced",CallingConvention=CallingConvention.StdCall)]
            public static extern int IsDebounced (System.IntPtr Instrument_Handle, out System.UInt16 Is_Debounced);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_WaitForDebounce",CallingConvention=CallingConvention.StdCall)]
            public static extern int WaitForDebounce (System.IntPtr Instrument_Handle, int Maximum_Time__ms_);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_CanConnect",CallingConvention=CallingConvention.StdCall)]
            public static extern int CanConnect (System.IntPtr Instrument_Handle, string Channel_1, string Channel_2, out int Path_Capability);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_SetPath",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetPath (System.IntPtr Instrument_Handle, string Path_List);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_GetPath",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetPath (System.IntPtr Instrument_Handle, string Channel_1, string Channel_2, int Buffer_Size, System.Text.StringBuilder Path);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_Scan",CallingConvention=CallingConvention.StdCall)]
            public static extern int Scan (System.IntPtr Instrument_Handle, string Scanlist, short Initiation);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_InitiateScan",CallingConvention=CallingConvention.StdCall)]
            public static extern int InitiateScan (System.IntPtr Instrument_Handle);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_AbortScan",CallingConvention=CallingConvention.StdCall)]
            public static extern int AbortScan (System.IntPtr Instrument_Handle);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_SendSoftwareTrigger",CallingConvention=CallingConvention.StdCall)]
            public static extern int SendSoftwareTrigger (System.IntPtr Instrument_Handle);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_IsScanning",CallingConvention=CallingConvention.StdCall)]
            public static extern int IsScanning (System.IntPtr Instrument_Handle, out System.UInt16 Is_Scanning);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_WaitForScanComplete",CallingConvention=CallingConvention.StdCall)]
            public static extern int WaitForScanComplete (System.IntPtr Instrument_Handle, int Maximum_Time__ms_);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_SetContinuousScan",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetContinuousScan (System.IntPtr Instrument_Handle, System.UInt16 Continuous_Scan);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_ConfigureScanList",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureScanList (System.IntPtr Instrument_Handle, string Scanlist, int Scan_Mode);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_ConfigureScanTrigger",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureScanTrigger (System.IntPtr Instrument_Handle, System.Double Scan_Delay, int Trigger_Input, int Scan_Advanced_Output);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_RouteTriggerInput",CallingConvention=CallingConvention.StdCall)]
            public static extern int RouteTriggerInput (System.IntPtr Instrument_Handle, int Trigger_Input_Connector, int Trigger_Input_Bus_Line, System.UInt16 Invert);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_RouteScanAdvancedOutput",CallingConvention=CallingConvention.StdCall)]
            public static extern int RouteScanAdvancedOutput (System.IntPtr Instrument_Handle, int Scan_Advanced_Output_Connector, int Scan_Advanced_Output_Bus_Line, System.UInt16 Invert);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_GetRelayName",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetRelayName (System.IntPtr Instrument_Handle, int Index, int Relay_Name_Buffer_Size, System.Text.StringBuilder Relay_Name_Buffer);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_GetRelayCount",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetRelayCount (System.IntPtr Instrument_Handle, string Relay_Name, out int Relay_Count);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_GetRelayPosition",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetRelayPosition (System.IntPtr Instrument_Handle, string Relay_Name, out int Relay_Position);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_RelayControl",CallingConvention=CallingConvention.StdCall)]
            public static extern int RelayControl (System.IntPtr Instrument_Handle, string Relay_Name, int Relay_Action);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_Commit",CallingConvention=CallingConvention.StdCall)]
            public static extern int Commit (System.IntPtr Instrument_Handle);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_GetChannelName",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetChannelName (System.IntPtr Instrument_Handle, int Index, int Buffer_Size, System.Text.StringBuilder Channel_Name_Buffer);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_reset",CallingConvention=CallingConvention.StdCall)]
            public static extern int reset (System.IntPtr Instrument_Handle);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_ResetWithDefaults",CallingConvention=CallingConvention.StdCall)]
            public static extern int ResetWithDefaults (System.IntPtr Instrument_Handle);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_Disable",CallingConvention=CallingConvention.StdCall)]
            public static extern int Disable (System.IntPtr Instrument_Handle);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_self_test",CallingConvention=CallingConvention.StdCall)]
            public static extern int self_test (System.IntPtr Instrument_Handle, out short Self_Test_Result, System.Text.StringBuilder Self_Test_Message);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_revision_query",CallingConvention=CallingConvention.StdCall)]
            public static extern int revision_query (System.IntPtr Instrument_Handle, System.Text.StringBuilder Instrument_Driver_Revision, System.Text.StringBuilder Firmware_Revision);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_error_query",CallingConvention=CallingConvention.StdCall)]
            public static extern int error_query (System.IntPtr Instrument_Handle, out int Error_Code, System.Text.StringBuilder Error_Message);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_GetNextCoercionRecord",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetNextCoercionRecord (System.IntPtr Instrument_Handle, int Buffer_Size, System.Text.StringBuilder Coercion_Record);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_GetNextInterchangeWarning",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetNextInterchangeWarning (System.IntPtr Instrument_Handle, int Buffer_Size, System.Text.StringBuilder Interchange_Warning);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_ClearInterchangeWarnings",CallingConvention=CallingConvention.StdCall)]
            public static extern int ClearInterchangeWarnings (System.IntPtr Instrument_Handle);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_ResetInterchangeCheck",CallingConvention=CallingConvention.StdCall)]
            public static extern int ResetInterchangeCheck (System.IntPtr Instrument_Handle);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_close",CallingConvention=CallingConvention.StdCall)]
            public static extern int close (System.IntPtr Instrument_Handle);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_error_message",CallingConvention=CallingConvention.StdCall)]
            public static extern int error_message (System.IntPtr Instrument_Handle, int Error_Code, System.Text.StringBuilder Error_Message_2);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_GetAttributeViInt32",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetAttributeViInt32 (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out int Attribute_Value);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_GetAttributeViReal64",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetAttributeViReal64 (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out System.Double Attribute_Value);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_GetAttributeViString",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetAttributeViString (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, int Array_Size, System.Text.StringBuilder Attribute_Value);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_GetAttributeViBoolean",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetAttributeViBoolean (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out System.UInt16 Attribute_Value);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_GetAttributeViSession",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetAttributeViSession (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out System.IntPtr Attribute_Value);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_SetAttributeViInt32",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetAttributeViInt32 (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, int Attribute_Value);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_SetAttributeViReal64",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetAttributeViReal64 (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, System.Double Attribute_Value);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_SetAttributeViString",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetAttributeViString (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, string Attribute_Value);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_SetAttributeViBoolean",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetAttributeViBoolean (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, System.UInt16 Attribute_Value);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_SetAttributeViSession",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetAttributeViSession (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, System.IntPtr Attribute_Value);
            
            [DllImport("niSwitch_32.dll",EntryPoint="niSwitch_GetError",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetError (System.IntPtr Instrument_Handle, out int Code, int BufferSize, System.Text.StringBuilder Description);
            
            public static int TestForError(System.IntPtr handle, int status)
            {
                if ((status < 0))
                {
                    PInvoke.ThrowError(handle, status);
                }
                return status;
            }
            
            public static int ThrowError(System.IntPtr handle, int code)
            {
                int status;
                int size = PInvoke.GetError(handle, out status, 0, null);
                System.Text.StringBuilder msg = new System.Text.StringBuilder();
                if ((size >= 0))
                {
                    msg.Capacity = size;
                    PInvoke.GetError(handle, out status, size, msg);
                }
                throw new System.Runtime.InteropServices.ExternalException(msg.ToString(), code);
            }
        }
    }
    
    public class niSwitchConstants
    {
        
        public const string Topology25032Wire4x6Matrix = "2503/2-Wire 4x6 Matrix";
        
        public const short SwitchInitiated = 1;
        
        public const string Topology25292Wire8x16Matrix = "2529/2-Wire 8x16 Matrix";
        
        public const string Topology1191Quad4x1Mux = "1191/Quad 4x1 Mux";
        
        public const string Topology25321WireSixteen2x16Matrix = "2532/1-Wire Sixteen 2x16 Matrix";
        
        public const string Topology1167Independent = "1167/Independent";
        
        public const string Topology11292WireDual8x16Matrix = "1129/2-Wire Dual 8x16 Matrix";
        
        public const string Topology25032WireQuad6x1Mux = "2503/2-Wire Quad 6x1 Mux";
        
        public const string Topology11301Wire8x32Matrix = "1130/1-Wire 8x32 Matrix";
        
        public const string Topology11618Spdt = "1161/8-SPDT";
        
        public const string Topology25014Wire12x1Mux = "2501/4-Wire 12x1 Mux";
        
        public const string Topology25301Wire128x1Mux = "2530/1-Wire 128x1 Mux";
        
        public const string Topology119332x1Mux = "1193/32x1 Mux";
        
        public const int External = 2;
        
        public const string Topology25012Wire24x1Mux = "2501/2-Wire 24x1 Mux";
        
        public const string Topology25292Wire4x32Matrix = "2529/2-Wire 4x32 Matrix";
        
        public const string Topology11292Wire16x16Matrix = "1129/2-Wire 16x16 Matrix";
        
        public const string Topology256831Spst = "2568/31-SPST";
        
        public const int Ttl0 = 111;
        
        public const int Ttl1 = 112;
        
        public const string Topology11282Wire32x1Mux = "1128/2-Wire 32x1 Mux";
        
        public const int Ttl3 = 114;
        
        public const int Ttl4 = 115;
        
        public const string Topology11284Wire16x1Mux = "1128/4-Wire 16x1 Mux";
        
        public const int Ttl6 = 117;
        
        public const int Ttl7 = 118;
        
        public const string Topology25938x1TerminatedMux = "2593/8x1 Terminated Mux";
        
        public const int CloseRelay = 21;
        
        public const int Frontconnector = 1001;
        
        public const string Topology2593Dual8x1Mux = "2593/Dual 8x1 Mux";
        
        public const int OpenRelay = 20;
        
        public const int RearconnectorModule8 = 1028;
        
        public const int PxiStar = 125;
        
        public const string Topology11282Wire4x8Matrix = "1128/2-Wire 4x8 Matrix";
        
        public const string Topology25904x1Mux = "2590/4x1 Mux";
        
        public const string Topology11272Wire32x1Mux = "1127/2-Wire 32x1 Mux";
        
        public const int RearconnectorModule3 = 1023;
        
        public const int RearconnectorModule1 = 1021;
        
        public const int Ttl2 = 113;
        
        public const string Topology11292Wire4x64Matrix = "1129/2-Wire 4x64 Matrix";
        
        public const string Topology25301Wire8x16Matrix = "2530/1-Wire 8x16 Matrix";
        
        public const int Ttl5 = 116;
        
        public const string Topology1127Independent = "1127/Independent";
        
        public const string Topology2593Independent = "2593/Independent";
        
        public const string Topology2567Independent = "2567/Independent";
        
        public const string Topology25032Wire24x1Mux = "2503/2-Wire 24x1 Mux";
        
        public const int FrontconnectorModule3 = 1043;
        
        public const int FrontconnectorModule2 = 1042;
        
        public const int FrontconnectorModule1 = 1041;
        
        public const string Topology1130Independent = "1130/Independent";
        
        public const int FrontconnectorModule7 = 1047;
        
        public const int FrontconnectorModule6 = 1046;
        
        public const string Topology25031Wire48x1Mux = "2503/1-Wire 48x1 Mux";
        
        public const string Topology25301Wire4x32Matrix = "2530/1-Wire 4x32 Matrix";
        
        public const string Topology25032WireDual12x1Mux = "2503/2-Wire Dual 12x1 Mux";
        
        public const int FrontconnectorModule9 = 1049;
        
        public const int FrontconnectorModule5 = 1045;
        
        public const string Topology1169100Spst = "1169/100-SPST";
        
        public const int FrontconnectorModule8 = 1048;
        
        public const string Topology1193Independent = "1193/Independent";
        
        public const string Topology11292Wire8x32Matrix = "1129/2-Wire 8x32 Matrix";
        
        public const string Topology1193Dual8x1TerminatedMux = "1193/Dual 8x1 Terminated Mux";
        
        public const string Topology25012Wire4x6Matrix = "2501/2-Wire 4x6 Matrix";
        
        public const string Topology25321Wire4x128Matrix = "2532/1-Wire 4x128 Matrix";
        
        public const string Topology11292WireQuad4x16Matrix = "1129/2-Wire Quad 4x16 Matrix";
        
        public const int FrontconnectorModule4 = 1044;
        
        public const string Topology25012WireQuad6x1Mux = "2501/2-Wire Quad 6x1 Mux";
        
        public const int RearconnectorModule6 = 1026;
        
        public const string Topology11301Wire256x1Mux = "1130/1-Wire 256x1 Mux";
        
        public const string Topology116016Spdt = "1160/16-SPDT";
        
        public const string Topology1163rOctal4x1Mux = "1163R/Octal 4x1 Mux";
        
        public const string Topology11274Wire16x1Mux = "1127/4-Wire 16x1 Mux";
        
        public const string Topology25292WireDual4x16Matrix = "2529/2-Wire Dual 4x16 Matrix";
        
        public const string Topology259316x1Mux = "2593/16x1 Mux";
        
        public const string Topology25321Wire8x64Matrix = "2532/1-Wire 8x64 Matrix";
        
        public const string Topology256516Spst = "2565/16-SPST";
        
        public const string Topology11271Wire64x1Mux = "1127/1-Wire 64x1 Mux";
        
        public const string Topology11281Wire64x1Mux = "1128/1-Wire 64x1 Mux";
        
        public const string Topology1193Quad8x1Mux = "1193/Quad 8x1 Mux";
        
        public const string Topology25012Wire24x1AmplifiedMux = "2501/2-Wire 24x1 Amplified Mux";
        
        public const string Topology25302Wire4x16Matrix = "2530/2-Wire 4x16 Matrix";
        
        public const string Topology11302Wire4x32Matrix = "1130/2-Wire 4x32 Matrix";
        
        public const string Topology119316x1TerminatedMux = "1193/16x1 Terminated Mux";
        
        public const string Topology11302Wire128x1Mux = "1130/2-Wire 128x1 Mux";
        
        public const string Topology25304Wire32x1Mux = "2530/4-Wire 32x1 Mux";
        
        public const string Topology11928Spdt = "1192/8-SPDT";
        
        public const string Topology257040Spdt = "2570/40-SPDT";
        
        public const string Topology11304Wire64x1Mux = "1130/4-Wire 64x1 Mux";
        
        public const string Topology11272Wire4x8Matrix = "1127/2-Wire 4x8 Matrix";
        
        public const string Topology25034Wire12x1Mux = "2503/4-Wire 12x1 Mux";
        
        public const string Topology1128Independent = "1128/Independent";
        
        public const string Topology116632Spdt = "1166/32-SPDT";
        
        public const string Topology1193Quad4x1TerminatedMux = "1193/Quad 4x1 Terminated Mux";
        
        public const string Topology2593Dual4x1TerminatedMux = "2593/Dual 4x1 Terminated Mux";
        
        public const int RearconnectorModule7 = 1027;
        
        public const int RearconnectorModule4 = 1024;
        
        public const int RearconnectorModule5 = 1025;
        
        public const int RearconnectorModule2 = 1022;
        
        public const int SoftwareTrig = 3;
        
        public const string Topology2530Independent = "2530/Independent";
        
        public const string Topology11301Wire4x64Matrix = "1130/1-Wire 4x64 Matrix";
        
        public const string Topology25914x1Mux = "2591/4x1 Mux";
        
        public const string Topology25302Wire64x1Mux = "2530/2-Wire 64x1 Mux";
        
        public const short MeasurementDeviceInitiated = 0;
        
        public const int RearconnectorModule9 = 1029;
        
        public const int Rearconnector = 1000;
        
        public const string Topology11292WireDual4x32Matrix = "1129/2-Wire Dual 4x32 Matrix";
        
        public const string Topology1193Dual16x1Mux = "1193/Dual 16x1 Mux";
        
        public const string Topology25011Wire48x1Mux = "2501/1-Wire 48x1 Mux";
        
        public const int BreakAfterMake = 2;
        
        public const int BreakBeforeMake = 1;
        
        public const string Topology25011Wire48x1AmplifiedMux = "2501/1-Wire 48x1 Amplified Mux";
        
        public const string Topology1190Quad4x1Mux = "1190/Quad 4x1 Mux";
        
        public const string Topology256616Spdt = "2566/16-SPDT";
        
        public const string Topology2569100Spst = "2569/100-SPST";
        
        public const string Topology25012WireDual12x1Mux = "2501/2-Wire Dual 12x1 Mux";
        
        public const int None = 0;
        
        public const int FrontconnectorModule12 = 1052;
        
        public const int FrontconnectorModule10 = 1050;
        
        public const int FrontconnectorModule11 = 1051;
        
        public const int Immediate = 1;
        
        public const int RearconnectorModule12 = 1032;
        
        public const int RearconnectorModule11 = 1031;
        
        public const int RearconnectorModule10 = 1030;
    }
    
    public enum niSwitchProperties
    {
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        RangeCheck = 1050002,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        QueryInstrumentStatus = 1050003,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        Cache = 1050004,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        Simulate = 1050005,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        RecordCoercions = 1050006,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        InterchangeCheck = 1050021,
        
        /// <summary>
        /// System.String
        /// </summary>
        SpecificDriverDescription = 1050514,
        
        /// <summary>
        /// System.String
        /// </summary>
        SpecificDriverPrefix = 1050302,
        
        /// <summary>
        /// System.String
        /// </summary>
        SpecificDriverVendor = 1050513,
        
        /// <summary>
        /// System.String
        /// </summary>
        SpecificDriverRevision = 1050551,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        SpecificDriverClassSpecMajorVersion = 1050515,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        SpecificDriverClassSpecMinorVersion = 1050516,
        
        /// <summary>
        /// System.String
        /// </summary>
        SupportedInstrumentModels = 1050327,
        
        /// <summary>
        /// System.String
        /// </summary>
        GroupCapabilities = 1050401,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        ChannelCount = 1050203,
        
        /// <summary>
        /// System.String
        /// </summary>
        InstrumentManufacturer = 1050511,
        
        /// <summary>
        /// System.String
        /// </summary>
        InstrumentModel = 1050512,
        
        /// <summary>
        /// System.String
        /// </summary>
        InstrumentFirmwareRevision = 1050510,
        
        /// <summary>
        /// System.String
        /// </summary>
        DriverSetup = 1050007,
        
        /// <summary>
        /// System.String
        /// </summary>
        LogicalName = 1050305,
        
        /// <summary>
        /// System.String
        /// </summary>
        IoResourceDescriptor = 1050304,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        IsSourceChannel = 1250001,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        IsConfigurationChannel = 1250003,
        
        /// <summary>
        /// System.String
        /// </summary>
        SerialNumber = 1150015,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        IsDebounced = 1250002,
        
        /// <summary>
        /// System.Double
        /// </summary>
        SettlingTime = 1250004,
        
        /// <summary>
        /// System.Double
        /// </summary>
        Bandwidth = 1250005,
        
        /// <summary>
        /// System.Double
        /// </summary>
        MaxDcVoltage = 1250006,
        
        /// <summary>
        /// System.Double
        /// </summary>
        MaxAcVoltage = 1250007,
        
        /// <summary>
        /// System.Double
        /// </summary>
        MaxSwitchingDcCurrent = 1250008,
        
        /// <summary>
        /// System.Double
        /// </summary>
        MaxSwitchingAcCurrent = 1250009,
        
        /// <summary>
        /// System.Double
        /// </summary>
        MaxCarryDcCurrent = 1250010,
        
        /// <summary>
        /// System.Double
        /// </summary>
        MaxCarryAcCurrent = 1250011,
        
        /// <summary>
        /// System.Double
        /// </summary>
        MaxSwitchingDcPower = 1250012,
        
        /// <summary>
        /// System.Double
        /// </summary>
        MaxSwitchingAcPower = 1250013,
        
        /// <summary>
        /// System.Double
        /// </summary>
        MaxCarryDcPower = 1250014,
        
        /// <summary>
        /// System.Double
        /// </summary>
        MaxCarryAcPower = 1250015,
        
        /// <summary>
        /// System.Double
        /// </summary>
        CharacteristicImpedance = 1250016,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        WireMode = 1250017,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        NumberOfRelays = 1150014,
        
        /// <summary>
        /// System.String
        /// </summary>
        ScanList = 1250020,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        ScanMode = 1250021,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        ContinuousScan = 1250026,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        TriggerInput = 1250022,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        ScanAdvancedOutput = 1250023,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        IsScanning = 1250024,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        IsWaitingForTrig = 1150004,
        
        /// <summary>
        /// System.Double
        /// </summary>
        ScanDelay = 1250025,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        TriggerInputPolarity = 1150010,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        ScanAdvancedPolarity = 1150011,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        HandshakingInitiation = 1150013,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        NumOfRows = 1250018,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        NumOfColumns = 1250019,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        CabledModuleScanAdvancedBus = 1150009,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        CabledModuleTriggerBus = 1150008,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        MasterSlaveScanAdvancedBus = 1150007,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        MasterSlaveTriggerBus = 1150006,
        
        /// <summary>
        /// System.String
        /// </summary>
        ParsedScanList = 1150012,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        TriggerMode = 1150005,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        SerialNumberI32 = 1150001,
    }
}
